// Licensed Materials - Use restricted, For use in compiling interfaces to IBM Rational TestManager.  

//  Copyright IBM Corporation 2006. All Rights Reserved. 





#if !defined(AFX_TESTINPUTAPI__INCLUDED__H)
#define AFX_TESTINPUTAPI__INCLUDED__H

#include <time.h>
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the TESTINPUTAPISAMPLE_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// TESTINPUTAPISAMPLE_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef TESTINPUTAPI_EXPORTS
#define TESTINPUTAPI_API __declspec(dllexport)
#else
#define TESTINPUTAPI_API __declspec(dllimport)
#endif

#define TI_MAX_ERROR 		260
#define TI_MAX_ID 			260
#define TI_MAX_TYPE 		260
#define TI_MAX_NAME 		260
#define TI_MAX_PATH			260
#define TI_MAX_ACTION_NAME	40

#define TI_SUCCESS						0
#define TI_ERROR_UNABLE_TO_CONNECT		1
#define TI_ERROR_INVALID_SOURCEID		2
#define TI_ERROR_UNABLE_TO_DISCONNECT	3
#define TI_ERROR_INVALID_CONNECTINFO	4
#define TI_NODE_NOT_FOUND				5
#define TI_ERROR						6
#define TI_CANCEL                       7
#define TI_FUNCTION_NOT_SUPPORTED       8


struct Node 
{
	TCHAR	Name[TI_MAX_NAME];
	TCHAR	NodeID[TI_MAX_ID];
	TCHAR	Type[TI_MAX_TYPE];
	BOOL	IsOnlyContainer;
	BOOL	NeedsValidation;
};

struct TIConnectOption
{
	TCHAR	Name[TI_MAX_NAME];
	TCHAR	Value[TI_MAX_NAME];
};


struct TIAction
{
	TCHAR	Name[TI_MAX_ACTION_NAME];
	int		ActionID;
};


#define TI_FUNCTION_TIConnect					1
#define TI_FUNCTION_TIConnectEx					2
#define TI_FUNCTION_TIDisconnect				3
#define TI_FUNCTION_TIGetRoots					4
#define TI_FUNCTION_TIGetChildren				5
#define TI_FUNCTION_TIGetNode					6
#define TI_FUNCTION_TIGetParent					7
#define TI_FUNCTION_TIGetName					8
#define TI_FUNCTION_TIGetType    				9
#define TI_FUNCTION_TIGetTypes					10
#define TI_FUNCTION_TIGetIsParent				11
#define TI_FUNCTION_TIGetIsValidSource			12
#define TI_FUNCTION_TIGetSourceIcon				13
#define TI_FUNCTION_TIGetTypeIcon				14
#define TI_FUNCTION_TIGetIsNode					15
#define TI_FUNCTION_TIGetIsChild				16
#define TI_FUNCTION_TIGetModified               17
#define TI_FUNCTION_TIGetModifiedSince          18
#define TI_FUNCTION_TISetValidationFilter       19
#define TI_FUNCTION_TISetFilter                 20
#define TI_FUNCTION_TIGetIsModified             21
#define TI_FUNCTION_TIShowProperties            22
#define TI_FUNCTION_TIShowSelectDialog          23
#define TI_FUNCTION_TIGetNeedsValidation        24
#define TI_FUNCTION_TIGetConfiguration			25
#define TI_FUNCTION_TIGetFilterEx				26
#define TI_FUNCTION_TIGetSourceActions			27
#define TI_FUNCTION_TIGetNodeActions			28
#define TI_FUNCTION_TISetConfiguration			29
#define TI_FUNCTION_TISetFilterEx				30
#define TI_FUNCTION_TIExecutionSourceAction		31
#define TI_FUNCTION_TIExecuteNodeAction			32
#define TI_FUNCTION_TIClearFilter				33
#define TI_FUNCTION_TISecureConnect				34


#ifdef TESTINPUTAPI_EXPORTS

TESTINPUTAPI_API HRESULT TIConnect(const TCHAR ConnectInfo[TI_MAX_PATH], const TCHAR UserID[TI_MAX_ID], TCHAR SourceID[TI_MAX_ID],  TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIDisconnect(const TCHAR SourceID[TI_MAX_ID], TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetRoots(const TCHAR SourceID[TI_MAX_ID], struct Node *pRootNodes[], long* plNodeCount, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetChildren(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], struct Node *pChildNodes[], long* plNodeCount, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetNode(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], struct Node** pNode, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetParent(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], struct Node** pParentNode, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetName(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], TCHAR Name[TI_MAX_NAME], TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetType(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], TCHAR Type[TI_MAX_TYPE], TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetTypes(const TCHAR SourceID[TI_MAX_ID], TCHAR (** Types)[TI_MAX_TYPE], long* pTypeCount, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetIsParent(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], BOOL* pbIsParent,  TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API BOOL TIGetIsValidSource(const TCHAR SourceID[TI_MAX_ID]);
TESTINPUTAPI_API HRESULT TIGetSourceIcon(const TCHAR SourceID[TI_MAX_ID], TCHAR IconPath[TI_MAX_PATH], TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetTypeIcon(const TCHAR SourceID[TI_MAX_ID], const TCHAR Type[TI_MAX_TYPE], TCHAR IconPath[TI_MAX_PATH], TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetIsNode(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], BOOL* pbIsNode, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetIsChild(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], BOOL* pbIsChild, TCHAR ErrorDescription[TI_MAX_ERROR]);

// Highly Recommended

TESTINPUTAPI_API HRESULT TIGetModified(const TCHAR SourceID[TI_MAX_ID], struct Node ModifiedNodes[], long* plNodeCount, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetModifiedSince(const TCHAR SourceID[TI_MAX_ID], struct tm tmDate, struct Node *pModifiedNodes[], long* plNodeCount, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TISetValidationFilter(const TCHAR SourceID[TI_MAX_ID], const TCHAR UserID[TI_MAX_ID], BOOL OnlyNeedsValidation, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TISetFilter(const TCHAR SourceID[TI_MAX_ID], const TCHAR UserID[TI_MAX_ID], TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetIsModified(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], BOOL* pbIsModified, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIShowProperties(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], struct Node** pModifiedNode, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIShowSelectDialog(const TCHAR SourceID[TI_MAX_ID], struct Node *pSelectedNodes[], long* plNodeCount, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetIsModifiedSince(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], struct tm tmDate, BOOL* pbIsModified, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetNeedsValidation(const TCHAR SourceID[TI_MAX_ID], const TCHAR NodeID[TI_MAX_ID], BOOL* pbNeedsValidation, TCHAR ErrorDescription[TI_MAX_ERROR]);

// New
TESTINPUTAPI_API HRESULT TIConnectEx(const TCHAR ConnectInfo[TI_MAX_PATH], const TCHAR UserID[TI_MAX_ID], const TIConnectOption *pConnectOptions, int nOptions, TCHAR SourceID[TI_MAX_ID],  TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetConfiguration(const TCHAR SourceID[TI_MAX_ID], long lWindowContext, TCHAR **pConfigurationBuffer, int* pnConfigurationBufferLength, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetFilterEx(const TCHAR SourceID[TI_MAX_ID], long lWindowContext, TCHAR **pFilterBuffer, int* pnFilterBufferLength, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetSourceActions(const TCHAR SourceID[TI_MAX_ID], struct TIAction *pActions[], int *pnActionCount, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIGetNodeActions(const TCHAR SourceID[TI_MAX_ID], const TCHAR Type[TI_MAX_TYPE], struct TIAction *pActions[], int *pnActionCount, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TISetConfiguration(const TCHAR SourceID[TI_MAX_ID], TCHAR *pConfigurationBuffer, int nConfigurationBufferLength, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TISetFilterEx(const TCHAR SourceID[TI_MAX_ID], TCHAR *pFilterBuffer, int nFilterBufferLength, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIExecuteSourceAction(const TCHAR SourceID[TI_MAX_ID], int nActionID, long lWindowContext, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIExecuteNodeAction(const TCHAR SourceID[TI_MAX_ID], const TCHAR Node[TI_MAX_ID], int nActionID, long lWindowContext, TCHAR ErrorDescription[TI_MAX_ERROR]);

TESTINPUTAPI_API HRESULT TIGetIsFunctionSupported(const TCHAR SourceID[TI_MAX_ID], const TCHAR Node[TI_MAX_ID], long lFunctionID, BOOL *pbIsSupported, TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TIClearFilter(const TCHAR SourceID[TI_MAX_ID], TCHAR ErrorDescription[TI_MAX_ERROR]);
TESTINPUTAPI_API HRESULT TISecureConnect(const TCHAR ConnectInfo[TI_MAX_PATH], const TCHAR UserID[TI_MAX_ID], const char Password[TI_MAX_ID], TCHAR SourceID[TI_MAX_ID], TCHAR ErrorDescription[TI_MAX_ERROR]);
#endif //TESTINPUTAPI_EXPORTS

#endif // !defined(AFX_TESTINPUTAPI__INCLUDED__H)
